// Written by Chris Miller
// vathix@dprogramming.com
// You may use this code freely


import ctype;


//debug = WILDCARD; //show all tests as it's happening (recursion)
//version = WILDTEST; //has main function and prompts for testing the function


debug(WILDCARD)
	import stream;


bit wildMatch(char[] wild, char[] str)
{
	debug(WILDCARD)
		stdout.writeString("wildMatch(\"" ~ wild ~ "\", \"" ~ str ~ "\")\n");
	
	uint wi, stri;
	for(stri = wi = 0; wi != wild.length; wi++)
	{
		switch(wild[wi])
		{
			case '*':
				if(wi == wild.length - 1)
					return true;
				
				wild = wild[++wi .. wild.length];
				for(; stri != str.length + 1; stri++)
				{
					if(wildMatch(wild, str[stri .. str.length]))
						return true;
				}
				return false;
			
			case '?':
				if(++stri > str.length)
					return wi == wild.length - 1;
				break;
			
			default:
				if(stri >= str.length)
					return false;
				
				if(ctype.tolower(wild[wi]) != ctype.tolower(str[stri]))
					return false;
				stri++;
		}
	}
	
	return stri == str.length;
}


unittest
{
	assert(wildMatch("Foo", "foo"));
	assert(wildMatch("f?o", "foo"));
	assert(wildMatch("f*", "foo"));
	assert(wildMatch("*", "foo"));
	assert(!wildMatch("f?", "foo"));
	assert(wildMatch("f?*o", "foo"));
	assert(wildMatch("?", "i"));
	assert(wildMatch("*world", "hello world"));
	assert(wildMatch("hello*d", "hello world"));
}


version(WILDTEST)
{
	import stream, string;
	
	int main()
	{
		for(;;)
		{
			stdout.writeString("\nThe wildcard tester (type QUIT to leave)!\n\nEnter a string> ");
			char[] str = stdin.readLine();
			if(!icmp(str, "QUIT"))
				break;
			
			stdout.writeString("Now a wildcard string> ");
			char[] wild = stdin.readLine();
			
			if(wildMatch(wild, str))
				stdout.writeString("They match!\n");
			else
				stdout.writeString("They do NOT match :(\n");
		}
		
		return 0;
	}
}

